# wallet_sendPreparedCalls

> For the complete documentation index, see [llms.txt](/docs/llms.txt).

POST https://api.g.alchemy.com/v2/{apiKey}

This method is used after signing the signatureRequest returned from prepareCalls to submit a user operation

Reference: https://www.alchemy.com/docs/wallets/api-reference/smart-wallets/wallet-api-endpoints/wallet-send-prepared-calls

## Parameters

| Name | Type | Required | Description |
|------|------|----------|-------------|
| params[0] | object | Yes |  |

## Result

**sendPreparedCallsResponse** (object)

## Example

### Request

```json
{
  "jsonrpc": "2.0",
  "method": "wallet_sendPreparedCalls",
  "params": [
    {
      "type": "user-operation-v070",
      "data": {
        "sender": "0xa363219d7C0b8673df17529D469Db9eFF0f35D2A",
        "nonce": "0x10000000000000000",
        "callData": "0x34fcd5be0000000000000000000000000000000000000000000000000000000000000020000000000000000000000000000000000000000000000000000000000000000100000000000000000000000000000000000000000000000000000000000000200000000000000000000000001234567890123456789012345678901234567890000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000600000000000000000000000000000000000000000000000000000000000000000",
        "paymaster": "0x3f222Df6aB18C1E10d0Ec136503c3B0dfd929048",
        "paymasterData": "0x0000000000000000682d7e7c9fa6f71c28c31141a11ac9eb2bdbe898ddbd42a4f7085f8bb3380ba75dd9231a386e24fe5a84777217c907391e983b5b0f78a4a9d0fd1c8631dd22c10e106b461c",
        "paymasterPostOpGasLimit": "0x0",
        "paymasterVerificationGasLimit": "0x74d3",
        "maxPriorityFeePerGas": "0x60e4b0",
        "maxFeePerGas": "0x1bf52290",
        "callGasLimit": "0x2bb8",
        "verificationGasLimit": "0xc845",
        "preVerificationGas": "0x14b74"
      },
      "chainId": "0x66eee",
      "signature": {
        "type": "secp256k1",
        "data": "0xb1a055089b1ba8387ed435f2bd0afe7ff69f22b928cdfdea1b5323c64d6af387164de3fa6febf031b544de46a84d6fb7f084b9798ddfaba820950c257139a7321b"
      }
    }
  ],
  "id": 1
}
```

### Response

```json
{
  "jsonrpc": "2.0",
  "result": {
    "id": "0x0000000000000000000000000000000000000000000000000000000000066eeec69e468aa6fafb5c7298c02841e76f976b433018266af39a5807bc29ea9ad392",
    "preparedCallIds": [
      "0x0000000000000000000000000000000000000000000000000000000000066eeec69e468aa6fafb5c7298c02841e76f976b433018266af39a5807bc29ea9ad392"
    ],
    "details": {
      "type": "user-operation",
      "data": {
        "hash": "0xc69e468aa6fafb5c7298c02841e76f976b433018266af39a5807bc29ea9ad392",
        "calls": [
          {
            "to": "0x1234567890123456789012345678901234567890",
            "data": "0x",
            "value": "0x0"
          }
        ]
      }
    }
  },
  "id": 1
}
```

## Code Examples

### cURL

```bash
curl --request POST \
  --url https://api.g.alchemy.com/v2/docs-demo \
  --header 'Content-Type: application/json' \
  --data '{
  "jsonrpc": "2.0",
  "id": 1,
  "method": "wallet_sendPreparedCalls",
  "params": [
    {
      "type": "user-operation-v070",
      "data": {
        "sender": "0xa363219d7C0b8673df17529D469Db9eFF0f35D2A",
        "nonce": "0x10000000000000000",
        "callData": "0x34fcd5be0000000000000000000000000000000000000000000000000000000000000020000000000000000000000000000000000000000000000000000000000000000100000000000000000000000000000000000000000000000000000000000000200000000000000000000000001234567890123456789012345678901234567890000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000600000000000000000000000000000000000000000000000000000000000000000",
        "paymaster": "0x3f222Df6aB18C1E10d0Ec136503c3B0dfd929048",
        "paymasterData": "0x0000000000000000682d7e7c9fa6f71c28c31141a11ac9eb2bdbe898ddbd42a4f7085f8bb3380ba75dd9231a386e24fe5a84777217c907391e983b5b0f78a4a9d0fd1c8631dd22c10e106b461c",
        "paymasterPostOpGasLimit": "0x0",
        "paymasterVerificationGasLimit": "0x74d3",
        "maxPriorityFeePerGas": "0x60e4b0",
        "maxFeePerGas": "0x1bf52290",
        "callGasLimit": "0x2bb8",
        "verificationGasLimit": "0xc845",
        "preVerificationGas": "0x14b74"
      },
      "chainId": "0x66eee",
      "signature": {
        "type": "secp256k1",
        "data": "0xb1a055089b1ba8387ed435f2bd0afe7ff69f22b928cdfdea1b5323c64d6af387164de3fa6febf031b544de46a84d6fb7f084b9798ddfaba820950c257139a7321b"
      }
    }
  ]
}'
```

### JavaScript

```javascript
const options = {
  method: 'POST',
  headers: {'Content-Type': 'application/json'},
  body: JSON.stringify({
    jsonrpc: '2.0',
    id: 1,
    method: 'wallet_sendPreparedCalls',
    params: [
      {
        type: 'user-operation-v070',
        data: {
          sender: '0xa363219d7C0b8673df17529D469Db9eFF0f35D2A',
          nonce: '0x10000000000000000',
          callData: '0x34fcd5be0000000000000000000000000000000000000000000000000000000000000020000000000000000000000000000000000000000000000000000000000000000100000000000000000000000000000000000000000000000000000000000000200000000000000000000000001234567890123456789012345678901234567890000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000600000000000000000000000000000000000000000000000000000000000000000',
          paymaster: '0x3f222Df6aB18C1E10d0Ec136503c3B0dfd929048',
          paymasterData: '0x0000000000000000682d7e7c9fa6f71c28c31141a11ac9eb2bdbe898ddbd42a4f7085f8bb3380ba75dd9231a386e24fe5a84777217c907391e983b5b0f78a4a9d0fd1c8631dd22c10e106b461c',
          paymasterPostOpGasLimit: '0x0',
          paymasterVerificationGasLimit: '0x74d3',
          maxPriorityFeePerGas: '0x60e4b0',
          maxFeePerGas: '0x1bf52290',
          callGasLimit: '0x2bb8',
          verificationGasLimit: '0xc845',
          preVerificationGas: '0x14b74'
        },
        chainId: '0x66eee',
        signature: {
          type: 'secp256k1',
          data: '0xb1a055089b1ba8387ed435f2bd0afe7ff69f22b928cdfdea1b5323c64d6af387164de3fa6febf031b544de46a84d6fb7f084b9798ddfaba820950c257139a7321b'
        }
      }
    ]
  })
};

fetch('https://api.g.alchemy.com/v2/docs-demo', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));
```

### Python

```python
import requests

url = "https://api.g.alchemy.com/v2/docs-demo"

payload = {
    "jsonrpc": "2.0",
    "id": 1,
    "method": "wallet_sendPreparedCalls",
    "params": [
        {
            "type": "user-operation-v070",
            "data": {
                "sender": "0xa363219d7C0b8673df17529D469Db9eFF0f35D2A",
                "nonce": "0x10000000000000000",
                "callData": "0x34fcd5be0000000000000000000000000000000000000000000000000000000000000020000000000000000000000000000000000000000000000000000000000000000100000000000000000000000000000000000000000000000000000000000000200000000000000000000000001234567890123456789012345678901234567890000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000600000000000000000000000000000000000000000000000000000000000000000",
                "paymaster": "0x3f222Df6aB18C1E10d0Ec136503c3B0dfd929048",
                "paymasterData": "0x0000000000000000682d7e7c9fa6f71c28c31141a11ac9eb2bdbe898ddbd42a4f7085f8bb3380ba75dd9231a386e24fe5a84777217c907391e983b5b0f78a4a9d0fd1c8631dd22c10e106b461c",
                "paymasterPostOpGasLimit": "0x0",
                "paymasterVerificationGasLimit": "0x74d3",
                "maxPriorityFeePerGas": "0x60e4b0",
                "maxFeePerGas": "0x1bf52290",
                "callGasLimit": "0x2bb8",
                "verificationGasLimit": "0xc845",
                "preVerificationGas": "0x14b74"
            },
            "chainId": "0x66eee",
            "signature": {
                "type": "secp256k1",
                "data": "0xb1a055089b1ba8387ed435f2bd0afe7ff69f22b928cdfdea1b5323c64d6af387164de3fa6febf031b544de46a84d6fb7f084b9798ddfaba820950c257139a7321b"
            }
        }
    ]
}
headers = {"Content-Type": "application/json"}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
```

### Go

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.g.alchemy.com/v2/docs-demo"

	payload := strings.NewReader("{\n  \"jsonrpc\": \"2.0\",\n  \"id\": 1,\n  \"method\": \"wallet_sendPreparedCalls\",\n  \"params\": [\n    {\n      \"type\": \"user-operation-v070\",\n      \"data\": {\n        \"sender\": \"0xa363219d7C0b8673df17529D469Db9eFF0f35D2A\",\n        \"nonce\": \"0x10000000000000000\",\n        \"callData\": \"0x34fcd5be0000000000000000000000000000000000000000000000000000000000000020000000000000000000000000000000000000000000000000000000000000000100000000000000000000000000000000000000000000000000000000000000200000000000000000000000001234567890123456789012345678901234567890000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000600000000000000000000000000000000000000000000000000000000000000000\",\n        \"paymaster\": \"0x3f222Df6aB18C1E10d0Ec136503c3B0dfd929048\",\n        \"paymasterData\": \"0x0000000000000000682d7e7c9fa6f71c28c31141a11ac9eb2bdbe898ddbd42a4f7085f8bb3380ba75dd9231a386e24fe5a84777217c907391e983b5b0f78a4a9d0fd1c8631dd22c10e106b461c\",\n        \"paymasterPostOpGasLimit\": \"0x0\",\n        \"paymasterVerificationGasLimit\": \"0x74d3\",\n        \"maxPriorityFeePerGas\": \"0x60e4b0\",\n        \"maxFeePerGas\": \"0x1bf52290\",\n        \"callGasLimit\": \"0x2bb8\",\n        \"verificationGasLimit\": \"0xc845\",\n        \"preVerificationGas\": \"0x14b74\"\n      },\n      \"chainId\": \"0x66eee\",\n      \"signature\": {\n        \"type\": \"secp256k1\",\n        \"data\": \"0xb1a055089b1ba8387ed435f2bd0afe7ff69f22b928cdfdea1b5323c64d6af387164de3fa6febf031b544de46a84d6fb7f084b9798ddfaba820950c257139a7321b\"\n      }\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(string(body))

}
```

### Java

```java
HttpResponse<String> response = Unirest.post("https://api.g.alchemy.com/v2/docs-demo")
  .header("Content-Type", "application/json")
  .body("{\n  \"jsonrpc\": \"2.0\",\n  \"id\": 1,\n  \"method\": \"wallet_sendPreparedCalls\",\n  \"params\": [\n    {\n      \"type\": \"user-operation-v070\",\n      \"data\": {\n        \"sender\": \"0xa363219d7C0b8673df17529D469Db9eFF0f35D2A\",\n        \"nonce\": \"0x10000000000000000\",\n        \"callData\": \"0x34fcd5be0000000000000000000000000000000000000000000000000000000000000020000000000000000000000000000000000000000000000000000000000000000100000000000000000000000000000000000000000000000000000000000000200000000000000000000000001234567890123456789012345678901234567890000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000600000000000000000000000000000000000000000000000000000000000000000\",\n        \"paymaster\": \"0x3f222Df6aB18C1E10d0Ec136503c3B0dfd929048\",\n        \"paymasterData\": \"0x0000000000000000682d7e7c9fa6f71c28c31141a11ac9eb2bdbe898ddbd42a4f7085f8bb3380ba75dd9231a386e24fe5a84777217c907391e983b5b0f78a4a9d0fd1c8631dd22c10e106b461c\",\n        \"paymasterPostOpGasLimit\": \"0x0\",\n        \"paymasterVerificationGasLimit\": \"0x74d3\",\n        \"maxPriorityFeePerGas\": \"0x60e4b0\",\n        \"maxFeePerGas\": \"0x1bf52290\",\n        \"callGasLimit\": \"0x2bb8\",\n        \"verificationGasLimit\": \"0xc845\",\n        \"preVerificationGas\": \"0x14b74\"\n      },\n      \"chainId\": \"0x66eee\",\n      \"signature\": {\n        \"type\": \"secp256k1\",\n        \"data\": \"0xb1a055089b1ba8387ed435f2bd0afe7ff69f22b928cdfdea1b5323c64d6af387164de3fa6febf031b544de46a84d6fb7f084b9798ddfaba820950c257139a7321b\"\n      }\n    }\n  ]\n}")
  .asString();
```

### C#

```csharp
using RestSharp;


var options = new RestClientOptions("https://api.g.alchemy.com/v2/docs-demo");
var client = new RestClient(options);
var request = new RestRequest("");
request.AddJsonBody("{\n  \"jsonrpc\": \"2.0\",\n  \"id\": 1,\n  \"method\": \"wallet_sendPreparedCalls\",\n  \"params\": [\n    {\n      \"type\": \"user-operation-v070\",\n      \"data\": {\n        \"sender\": \"0xa363219d7C0b8673df17529D469Db9eFF0f35D2A\",\n        \"nonce\": \"0x10000000000000000\",\n        \"callData\": \"0x34fcd5be0000000000000000000000000000000000000000000000000000000000000020000000000000000000000000000000000000000000000000000000000000000100000000000000000000000000000000000000000000000000000000000000200000000000000000000000001234567890123456789012345678901234567890000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000600000000000000000000000000000000000000000000000000000000000000000\",\n        \"paymaster\": \"0x3f222Df6aB18C1E10d0Ec136503c3B0dfd929048\",\n        \"paymasterData\": \"0x0000000000000000682d7e7c9fa6f71c28c31141a11ac9eb2bdbe898ddbd42a4f7085f8bb3380ba75dd9231a386e24fe5a84777217c907391e983b5b0f78a4a9d0fd1c8631dd22c10e106b461c\",\n        \"paymasterPostOpGasLimit\": \"0x0\",\n        \"paymasterVerificationGasLimit\": \"0x74d3\",\n        \"maxPriorityFeePerGas\": \"0x60e4b0\",\n        \"maxFeePerGas\": \"0x1bf52290\",\n        \"callGasLimit\": \"0x2bb8\",\n        \"verificationGasLimit\": \"0xc845\",\n        \"preVerificationGas\": \"0x14b74\"\n      },\n      \"chainId\": \"0x66eee\",\n      \"signature\": {\n        \"type\": \"secp256k1\",\n        \"data\": \"0xb1a055089b1ba8387ed435f2bd0afe7ff69f22b928cdfdea1b5323c64d6af387164de3fa6febf031b544de46a84d6fb7f084b9798ddfaba820950c257139a7321b\"\n      }\n    }\n  ]\n}", false);
var response = await client.PostAsync(request);

Console.WriteLine("{0}", response.Content);

```


## OpenRPC Method Specification

```yaml
name: wallet_sendPreparedCalls
description: This method is used after signing the signatureRequest returned from prepareCalls to submit a user operation
params:
  - name: params[0]
    required: true
    schema:
      anyOf:
        - type: object
          required:
            - type
            - data
          properties:
            type:
              type: string
              enum:
                - array
            data:
              type: array
              items:
                anyOf:
                  - description: Prepared User Operation (Entrypoint v0.6.0) with signature
                    type: object
                    required:
                      - chainId
                      - data
                      - signature
                      - type
                    properties:
                      type:
                        type: string
                        description: User Operation (Entrypoint v0.6.0)
                        enum:
                          - user-operation-v060
                      data:
                        type: object
                        required:
                          - sender
                          - nonce
                          - initCode
                          - callData
                          - callGasLimit
                          - verificationGasLimit
                          - preVerificationGas
                          - maxFeePerGas
                          - maxPriorityFeePerGas
                          - paymasterAndData
                        description: Unsigned User Operation (Entrypoint v0.6.0)
                        properties:
                          sender:
                            type: string
                            pattern: ^0x.*$
                            errorMessage: Must be a valid Ethereum address starting with '0x' (e.g., '0xa363219d7C0b8673df17529D469Db9eFF0f35D2A')
                          nonce:
                            type: string
                            pattern: ^0x.*$
                            errorMessage: Must be a valid hex string starting with '0x'
                          initCode:
                            anyOf:
                              - type: string
                                pattern: ^0x.*$
                                errorMessage: Must be a valid hex string starting with '0x'
                                description: Present
                              - type: string
                                description: Absent
                                enum:
                                  - 0x
                          callData:
                            type: string
                            pattern: ^0x.*$
                            errorMessage: Must be a valid hex string starting with '0x'
                          callGasLimit:
                            type: string
                            pattern: ^0x.*$
                            errorMessage: Must be a valid hex string starting with '0x'
                          verificationGasLimit:
                            type: string
                            pattern: ^0x.*$
                            errorMessage: Must be a valid hex string starting with '0x'
                          preVerificationGas:
                            type: string
                            pattern: ^0x.*$
                            errorMessage: Must be a valid hex string starting with '0x'
                          maxFeePerGas:
                            type: string
                            pattern: ^0x.*$
                            errorMessage: Must be a valid hex string starting with '0x'
                          maxPriorityFeePerGas:
                            type: string
                            pattern: ^0x.*$
                            errorMessage: Must be a valid hex string starting with '0x'
                          paymasterAndData:
                            anyOf:
                              - type: string
                                pattern: ^0x.*$
                                errorMessage: Must be a valid hex string starting with '0x'
                                description: Present
                              - type: string
                                description: Absent
                                enum:
                                  - 0x
                      chainId:
                        type: string
                        pattern: ^0x.*$
                        errorMessage: Must be a valid hex string starting with '0x'
                      signature:
                        anyOf:
                          - type: object
                            required:
                              - type
                              - data
                            properties:
                              type:
                                type: string
                                enum:
                                  - secp256k1
                              data:
                                anyOf:
                                  - type: string
                                    pattern: ^0x.*$
                                    errorMessage: Must be a valid hex string starting with '0x'
                                    description: Hex-encoded signature
                                  - type: object
                                    required:
                                      - r
                                      - s
                                      - yParity
                                    properties:
                                      r:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                      s:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                      yParity:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                    description: r, s, yParity
                                  - type: object
                                    required:
                                      - r
                                      - s
                                      - v
                                    properties:
                                      r:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                      s:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                      v:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                    description: r, s, v
                            description: Secp256k1 signature
                          - type: object
                            required:
                              - type
                              - data
                            properties:
                              type:
                                type: string
                                enum:
                                  - ecdsa
                              data:
                                anyOf:
                                  - type: string
                                    pattern: ^0x.*$
                                    errorMessage: Must be a valid hex string starting with '0x'
                                    description: Hex-encoded signature
                                  - type: object
                                    required:
                                      - r
                                      - s
                                      - yParity
                                    properties:
                                      r:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                      s:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                      yParity:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                    description: r, s, yParity
                                  - type: object
                                    required:
                                      - r
                                      - s
                                      - v
                                    properties:
                                      r:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                      s:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                      v:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                    description: r, s, v
                            description: ECDSA signature (alias for secp256k1)
                  - description: Prepared User Operation (Entrypoint v0.7.0) with signature
                    type: object
                    required:
                      - chainId
                      - data
                      - signature
                      - type
                    properties:
                      type:
                        type: string
                        description: User Operation (Entrypoint v0.7.0)
                        enum:
                          - user-operation-v070
                      data:
                        type: object
                        required:
                          - sender
                          - nonce
                          - callData
                          - callGasLimit
                          - verificationGasLimit
                          - preVerificationGas
                          - maxFeePerGas
                          - maxPriorityFeePerGas
                        description: Unsigned User Operation (Entrypoint v0.7.0)
                        properties:
                          sender:
                            type: string
                            pattern: ^0x.*$
                            errorMessage: Must be a valid Ethereum address starting with '0x' (e.g., '0xa363219d7C0b8673df17529D469Db9eFF0f35D2A')
                          nonce:
                            type: string
                            pattern: ^0x.*$
                            errorMessage: Must be a valid hex string starting with '0x'
                          factory:
                            type: string
                            pattern: ^0x.*$
                            errorMessage: Must be a valid Ethereum address starting with '0x' (e.g., '0xa363219d7C0b8673df17529D469Db9eFF0f35D2A')
                          factoryData:
                            type: string
                            pattern: ^0x.*$
                            errorMessage: Must be a valid hex string starting with '0x'
                          callData:
                            type: string
                            pattern: ^0x.*$
                            errorMessage: Must be a valid hex string starting with '0x'
                          callGasLimit:
                            type: string
                            pattern: ^0x.*$
                            errorMessage: Must be a valid hex string starting with '0x'
                          verificationGasLimit:
                            type: string
                            pattern: ^0x.*$
                            errorMessage: Must be a valid hex string starting with '0x'
                          preVerificationGas:
                            type: string
                            pattern: ^0x.*$
                            errorMessage: Must be a valid hex string starting with '0x'
                          maxFeePerGas:
                            type: string
                            pattern: ^0x.*$
                            errorMessage: Must be a valid hex string starting with '0x'
                          maxPriorityFeePerGas:
                            type: string
                            pattern: ^0x.*$
                            errorMessage: Must be a valid hex string starting with '0x'
                          paymaster:
                            type: string
                            pattern: ^0x.*$
                            errorMessage: Must be a valid Ethereum address starting with '0x' (e.g., '0xa363219d7C0b8673df17529D469Db9eFF0f35D2A')
                          paymasterData:
                            type: string
                            pattern: ^0x.*$
                            errorMessage: Must be a valid hex string starting with '0x'
                          paymasterVerificationGasLimit:
                            type: string
                            pattern: ^0x.*$
                            errorMessage: Must be a valid hex string starting with '0x'
                          paymasterPostOpGasLimit:
                            type: string
                            pattern: ^0x.*$
                            errorMessage: Must be a valid hex string starting with '0x'
                      chainId:
                        type: string
                        pattern: ^0x.*$
                        errorMessage: Must be a valid hex string starting with '0x'
                      signature:
                        anyOf:
                          - type: object
                            required:
                              - type
                              - data
                            properties:
                              type:
                                type: string
                                enum:
                                  - secp256k1
                              data:
                                anyOf:
                                  - type: string
                                    pattern: ^0x.*$
                                    errorMessage: Must be a valid hex string starting with '0x'
                                    description: Hex-encoded signature
                                  - type: object
                                    required:
                                      - r
                                      - s
                                      - yParity
                                    properties:
                                      r:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                      s:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                      yParity:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                    description: r, s, yParity
                                  - type: object
                                    required:
                                      - r
                                      - s
                                      - v
                                    properties:
                                      r:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                      s:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                      v:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                    description: r, s, v
                            description: Secp256k1 signature
                          - type: object
                            required:
                              - type
                              - data
                            properties:
                              type:
                                type: string
                                enum:
                                  - ecdsa
                              data:
                                anyOf:
                                  - type: string
                                    pattern: ^0x.*$
                                    errorMessage: Must be a valid hex string starting with '0x'
                                    description: Hex-encoded signature
                                  - type: object
                                    required:
                                      - r
                                      - s
                                      - yParity
                                    properties:
                                      r:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                      s:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                      yParity:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                    description: r, s, yParity
                                  - type: object
                                    required:
                                      - r
                                      - s
                                      - v
                                    properties:
                                      r:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                      s:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                      v:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                    description: r, s, v
                            description: ECDSA signature (alias for secp256k1)
                  - description: Prepared EIP-7702 Authorization with signature
                    type: object
                    required:
                      - chainId
                      - data
                      - signature
                      - type
                    properties:
                      type:
                        type: string
                        description: EIP-7702 Authorization Request
                        enum:
                          - authorization
                      data:
                        type: object
                        required:
                          - address
                          - nonce
                        properties:
                          address:
                            type: string
                            pattern: ^0x.*$
                            errorMessage: Must be a valid Ethereum address starting with '0x' (e.g., '0xa363219d7C0b8673df17529D469Db9eFF0f35D2A')
                          nonce:
                            type: string
                            pattern: ^0x.*$
                            errorMessage: Must be a valid hex string starting with '0x'
                      chainId:
                        type: string
                        pattern: ^0x.*$
                        errorMessage: Must be a valid hex string starting with '0x'
                      signature:
                        anyOf:
                          - type: object
                            required:
                              - type
                              - data
                            properties:
                              type:
                                type: string
                                enum:
                                  - secp256k1
                              data:
                                anyOf:
                                  - type: string
                                    pattern: ^0x.*$
                                    errorMessage: Must be a valid hex string starting with '0x'
                                    description: Hex-encoded signature
                                  - type: object
                                    required:
                                      - r
                                      - s
                                      - yParity
                                    properties:
                                      r:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                      s:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                      yParity:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                    description: r, s, yParity
                                  - type: object
                                    required:
                                      - r
                                      - s
                                      - v
                                    properties:
                                      r:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                      s:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                      v:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                    description: r, s, v
                            description: Secp256k1 signature
                          - type: object
                            required:
                              - type
                              - data
                            properties:
                              type:
                                type: string
                                enum:
                                  - ecdsa
                              data:
                                anyOf:
                                  - type: string
                                    pattern: ^0x.*$
                                    errorMessage: Must be a valid hex string starting with '0x'
                                    description: Hex-encoded signature
                                  - type: object
                                    required:
                                      - r
                                      - s
                                      - yParity
                                    properties:
                                      r:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                      s:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                      yParity:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                    description: r, s, yParity
                                  - type: object
                                    required:
                                      - r
                                      - s
                                      - v
                                    properties:
                                      r:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                      s:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                      v:
                                        type: string
                                        pattern: ^0x.*$
                                        errorMessage: Must be a valid hex string starting with '0x'
                                    description: r, s, v
                            description: ECDSA signature (alias for secp256k1)
          description: Array of prepared calls with signatures
        - description: Prepared User Operation (Entrypoint v0.6.0) with signature
          type: object
          required:
            - chainId
            - data
            - signature
            - type
          properties:
            type:
              type: string
              description: User Operation (Entrypoint v0.6.0)
              enum:
                - user-operation-v060
            data:
              type: object
              required:
                - sender
                - nonce
                - initCode
                - callData
                - callGasLimit
                - verificationGasLimit
                - preVerificationGas
                - maxFeePerGas
                - maxPriorityFeePerGas
                - paymasterAndData
              description: Unsigned User Operation (Entrypoint v0.6.0)
              properties:
                sender:
                  type: string
                  pattern: ^0x.*$
                  errorMessage: Must be a valid Ethereum address starting with '0x' (e.g., '0xa363219d7C0b8673df17529D469Db9eFF0f35D2A')
                nonce:
                  type: string
                  pattern: ^0x.*$
                  errorMessage: Must be a valid hex string starting with '0x'
                initCode:
                  anyOf:
                    - type: string
                      pattern: ^0x.*$
                      errorMessage: Must be a valid hex string starting with '0x'
                      description: Present
                    - type: string
                      description: Absent
                      enum:
                        - 0x
                callData:
                  type: string
                  pattern: ^0x.*$
                  errorMessage: Must be a valid hex string starting with '0x'
                callGasLimit:
                  type: string
                  pattern: ^0x.*$
                  errorMessage: Must be a valid hex string starting with '0x'
                verificationGasLimit:
                  type: string
                  pattern: ^0x.*$
                  errorMessage: Must be a valid hex string starting with '0x'
                preVerificationGas:
                  type: string
                  pattern: ^0x.*$
                  errorMessage: Must be a valid hex string starting with '0x'
                maxFeePerGas:
                  type: string
                  pattern: ^0x.*$
                  errorMessage: Must be a valid hex string starting with '0x'
                maxPriorityFeePerGas:
                  type: string
                  pattern: ^0x.*$
                  errorMessage: Must be a valid hex string starting with '0x'
                paymasterAndData:
                  anyOf:
                    - type: string
                      pattern: ^0x.*$
                      errorMessage: Must be a valid hex string starting with '0x'
                      description: Present
                    - type: string
                      description: Absent
                      enum:
                        - 0x
            chainId:
              type: string
              pattern: ^0x.*$
              errorMessage: Must be a valid hex string starting with '0x'
            signature:
              anyOf:
                - type: object
                  required:
                    - type
                    - data
                  properties:
                    type:
                      type: string
                      enum:
                        - secp256k1
                    data:
                      anyOf:
                        - type: string
                          pattern: ^0x.*$
                          errorMessage: Must be a valid hex string starting with '0x'
                          description: Hex-encoded signature
                        - type: object
                          required:
                            - r
                            - s
                            - yParity
                          properties:
                            r:
                              type: string
                              pattern: ^0x.*$
                              errorMessage: Must be a valid hex string starting with '0x'
                            s:
                              type: string
                              pattern: ^0x.*$
                              errorMessage: Must be a valid hex string starting with '0x'
                            yParity:
                              type: string
                              pattern: ^0x.*$
                              errorMessage: Must be a valid hex string starting with '0x'
                          description: r, s, yParity
                        - type: object
                          required:
                            - r
                            - s
                            - v
                          properties:
                            r:
                              type: string
                              pattern: ^0x.*$
                              errorMessage: Must be a valid hex string starting with '0x'
                            s:
                              type: string
                              pattern: ^0x.*$
                              errorMessage: Must be a valid hex string starting with '0x'
                            v:
                              type: string
                              pattern: ^0x.*$
                              errorMessage: Must be a valid hex string starting with '0x'
                          description: r, s, v
                  description: Secp256k1 signature
                - type: object
                  required:
                    - type
                    - data
                  properties:
                    type:
                      type: string
                      enum:
                        - ecdsa
                    data:
                      anyOf:
                        - type: string
                          pattern: ^0x.*$
                          errorMessage: Must be a valid hex string starting with '0x'
                          description: Hex-encoded signature
                        - type: object
                          required:
                            - r
                            - s
                            - yParity
                          properties:
                            r:
                              type: string
                              pattern: ^0x.*$
                              errorMessage: Must be a valid hex string starting with '0x'
                            s:
                              type: string
                              pattern: ^0x.*$
                              errorMessage: Must be a valid hex string starting with '0x'
                            yParity:
                              type: string
                              pattern: ^0x.*$
                              errorMessage: Must be a valid hex string starting with '0x'
                          description: r, s, yParity
                        - type: object
                          required:
                            - r
                            - s
                            - v
                          properties:
                            r:
                              type: string
                              pattern: ^0x.*$
                              errorMessage: Must be a valid hex string starting with '0x'
                            s:
                              type: string
                              pattern: ^0x.*$
                              errorMessage: Must be a valid hex string starting with '0x'
                            v:
                              type: string
                              pattern: ^0x.*$
                              errorMessage: Must be a valid hex string starting with '0x'
                          description: r, s, v
                  description: ECDSA signature (alias for secp256k1)
        - description: Prepared User Operation (Entrypoint v0.7.0) with signature
          type: object
          required:
            - chainId
            - data
            - signature
            - type
          properties:
            type:
              type: string
              description: User Operation (Entrypoint v0.7.0)
              enum:
                - user-operation-v070
            data:
              type: object
              required:
                - sender
                - nonce
                - callData
                - callGasLimit
                - verificationGasLimit
                - preVerificationGas
                - maxFeePerGas
                - maxPriorityFeePerGas
              description: Unsigned User Operation (Entrypoint v0.7.0)
              properties:
                sender:
                  type: string
                  pattern: ^0x.*$
                  errorMessage: Must be a valid Ethereum address starting with '0x' (e.g., '0xa363219d7C0b8673df17529D469Db9eFF0f35D2A')
                nonce:
                  type: string
                  pattern: ^0x.*$
                  errorMessage: Must be a valid hex string starting with '0x'
                factory:
                  type: string
                  pattern: ^0x.*$
                  errorMessage: Must be a valid Ethereum address starting with '0x' (e.g., '0xa363219d7C0b8673df17529D469Db9eFF0f35D2A')
                factoryData:
                  type: string
                  pattern: ^0x.*$
                  errorMessage: Must be a valid hex string starting with '0x'
                callData:
                  type: string
                  pattern: ^0x.*$
                  errorMessage: Must be a valid hex string starting with '0x'
                callGasLimit:
                  type: string
                  pattern: ^0x.*$
                  errorMessage: Must be a valid hex string starting with '0x'
                verificationGasLimit:
                  type: string
                  pattern: ^0x.*$
                  errorMessage: Must be a valid hex string starting with '0x'
                preVerificationGas:
                  type: string
                  pattern: ^0x.*$
                  errorMessage: Must be a valid hex string starting with '0x'
                maxFeePerGas:
                  type: string
                  pattern: ^0x.*$
                  errorMessage: Must be a valid hex string starting with '0x'
                maxPriorityFeePerGas:
                  type: string
                  pattern: ^0x.*$
                  errorMessage: Must be a valid hex string starting with '0x'
                paymaster:
                  type: string
                  pattern: ^0x.*$
                  errorMessage: Must be a valid Ethereum address starting with '0x' (e.g., '0xa363219d7C0b8673df17529D469Db9eFF0f35D2A')
                paymasterData:
                  type: string
                  pattern: ^0x.*$
                  errorMessage: Must be a valid hex string starting with '0x'
                paymasterVerificationGasLimit:
                  type: string
                  pattern: ^0x.*$
                  errorMessage: Must be a valid hex string starting with '0x'
                paymasterPostOpGasLimit:
                  type: string
                  pattern: ^0x.*$
                  errorMessage: Must be a valid hex string starting with '0x'
            chainId:
              type: string
              pattern: ^0x.*$
              errorMessage: Must be a valid hex string starting with '0x'
# ... truncated (17310 chars) to keep this page under agent context limits.
```
